# avfvideosrc

Reads frames from an iOS AVFoundation device

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSrc
                        ╰──GstPushSrc
                            ╰──avfvideosrc

## Factory details

Authors: – Ole André Vadla Ravnås

Classification: – `Source/Video/Hardware`

Rank – secondary

Plugin – applemedia

Package – GStreamer Bad Plug-ins

## Pad Templates

### `src`

    video/x-raw(memory:GLMemory):
             format: UYVY
              width: [ 1, 2147483647 ]
             height: [ 1, 2147483647 ]
          framerate: [ 0/1, 2147483647/1 ]
     texture-target: rectangle
    video/x-raw:
             format: { NV12, UYVY, YUY2 }
          framerate: [ 0/1, 2147483647/1 ]
              width: [ 1, 2147483647 ]
             height: [ 1, 2147483647 ]
    video/x-raw:
             format: BGRA
          framerate: [ 0/1, 2147483647/1 ]
              width: [ 1, 2147483647 ]
             height: [ 1, 2147483647 ]

Presence – always

Direction – src

Object type – GstPad

## Properties

### capture-screen

    “capture-screen” gboolean

Enable screen capture functionality

Flags : Read / Write

Default value : false

### capture-screen-cursor

    “capture-screen-cursor” gboolean

Enable cursor capture while capturing screen

Flags : Read / Write

Default value : false

### capture-screen-mouse-clicks

    “capture-screen-mouse-clicks” gboolean

Enable mouse clicks capture while capturing screen

Flags : Read / Write

Default value : false

### device-index

    “device-index” gint

The zero-based device index

Flags : Read / Write

Default value : -1

### device-name

    “device-name” gchararray

The name of the currently opened capture device

Flags : Read

Default value : NULL

### device-type

    “device-type” Avfvideo-source-device-type *

The general type of a video capture device

Flags : Read / Write

Default value : default (0)

### do-stats

    “do-stats” gboolean

Enable logging of statistics

Flags : Read / Write

Default value : false

### fps

    “fps” gint

Last measured framerate, if statistics are enabled

Flags : Read

Default value : 0

### orientation

    “orientation” Avfvideo-source-orientation *

The orientation of the video

Flags : Read / Write

Default value : default (0)

### position

    “position” Avfvideo-source-position *

The position of the capture device (front or back-facing)

Flags : Read / Write

Default value : default (0)

## Named constants

### Avfvideo-source-device-type

#### Members

`wide-angle` (1) – A built-in wide angle camera. These devices are suitable for general purpose use.
`telephoto` (2) – A built-in camera device with a longer focal length than a wide-angle camera.
`dual` (3) – A dual camera device, combining built-in wide-angle and telephoto cameras that work together as a single capture device.
`default` (0) – Default

### Avfvideo-source-orientation

#### Members

`portrait` (1) – Indicates that video should be oriented vertically, top at the top.
`portrat-upside-down` (2) – Indicates that video should be oriented vertically, top at the bottom.
`landscape-right` (3) – Indicates that video should be oriented horizontally, top on the left.
`landscape-left` (4) – Indicates that video should be oriented horizontally, top on the right.
`default` (0) – Default

### Avfvideo-source-position

#### Members

`front` (1) – Front-facing camera
`back` (2) – Back-facing camera
`default` (0) – Default

The results of the search are